import java.awt.*;
import java.awt.event.*;
import java.util.Date;

import java.net.*;
import javax.net.ssl.*;
import java.security.Security;
import com.sun.net.ssl.*;
import java.security.cert.*;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

public class fireflier extends Frame implements WindowListener, Runnable
{
    // These are the labels and checkboxes visible in the interface
    Label label_len; // Length of packet
    Label label_tcp_flags; 
    Label label_icmp_type;
    Label label_arrived; // when id the packet arrive at the server
    Label label_hook; // == chain
    Label label_mac_addr; // hardware address of network interface card
    Label label_ip_src; // resolved name of source of packet
    Label label_ip_dst; // resolved name of destination of packet

    Checkbox cb_ip_src; // source ip
    Checkbox cb_ip_dst; // destination ip
    Checkbox cb_port_src;
    Checkbox cb_port_dst;
    Checkbox cb_interface_in;
    Checkbox cb_interface_out;
//    Checkbox cb_mac_addr;
    Checkbox cb_protocol; 
    Checkbox cb_conntrack;

    Checkbox cb_this_packet;
    Checkbox cb_queued_packets;
    Checkbox cb_create_rule;
    Checkbox cb_programname;

    Choice ch_timeout; // timeouting rules

    lookupThread lookupThr; // this thread does resolve the ip-addresses to hostnames

    int curMsglen=-1;
    public static final int PACKETLEN=68;
    public static final String[] ICMP_TYPES={"ECHO_REPLY", "UNKNOWN", "UNKNOWN", "DEST_UNREACH", "SOURCE_QUENCH", "REDIRECT", "UNKNOWN", "UNKNOWN", "ECHO", "UNKNOWN", "UNKNOWN", "TIME_EXCEEDED", "PARAMETERPROB", "TIMESTAMP", "TIMESTAMP_REPLY", "INFO_REQUEST", "INFO_REPLY", "ADDRESS", "ADDRESS_REPLY"};
    public static final char[] HEX={'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};

    SSLSocket socket=null;
    static String ServerIP;
    static String ServerPort;

    // not beautiful: these shouldnt need to be global
    myDialog iptables_dia=null; // Dialog showing iptables rules
    myDialog userspace_dia=null; // Dialog showing userspace rules
    List iptables_dialogList=null; // the List for iptables-dialog
    List userspace_dialogList=null; // the List for userspace-dialog
    int inputStart=-1; // used when working with iptables Dialog (needed for deletion of rules)
    int outputStart=-1;
    int forwardStart=-1;

    // for accepting connections ignoring unknown certificate
    // I do use the SSL libraries only for encrypting, not for validating the identity
    class MyX509TrustManager implements X509TrustManager
    {
        public boolean isClientTrusted(java.security.cert.X509Certificate[] chain){ return true;}
        public boolean isServerTrusted(java.security.cert.X509Certificate[] chain){ return true; }
        public X509Certificate[] getAcceptedIssuers() { return null; }
    }
    
    // this thread does domain name lookups (IP->domain name)
    class lookupThread implements Runnable {
        // ips which should be resolved
        private String srcip="";
        private String dstip="";
        
        public lookupThread()
        {
        }

        // set ips to resolve
        public void lookup(String asrcip, String adstip)
        {
            srcip=asrcip;
            dstip=adstip;
        }

        // main loop which resolves ips whenever a new one is found
        public void run() // Connection to server
        {
            String lsrcip="";
            String ldstip="";
            String result;

            while (true)
            {
                // lookup source ip
                try {
                    lsrcip=srcip;
                    InetAddress i=InetAddress.getByName(lsrcip);
                    result=i.getHostName();
                    if (srcip.equals(lsrcip))
                    {
                        label_ip_src.setText(result);
                        srcip="";
                    }
                }
                catch (UnknownHostException uh)
                {
                    System.out.println("Lookup error");
                }

                // lookup destination ip
                try {
                    ldstip=dstip;
                    InetAddress i=InetAddress.getByName(ldstip);
                    result=i.getHostName();
                    if (ldstip.equals(dstip))
                    {
                        label_ip_dst.setText(result);
                        dstip="";
                    }
                }
                catch (UnknownHostException uh)
                {
                    System.out.println("Lookup error");
                }
                try {
                    while (srcip.equals(""))
                        Thread.sleep(1000);
                }
                catch (InterruptedException ie)
                {
                }
                
            }
        }
    }

    // a custom Dialog class which handles close commands and sets your own fonts.
    class myDialog extends Dialog implements WindowListener
    {
        public myDialog(Frame f, String title, boolean modal)
        {
            super(f, title, modal);
            this.setFont(new Font("Courier", Font.BOLD, 12));
            this.addWindowListener(this);
        }
        public void windowOpened(WindowEvent e)
        {
        }
        public void windowClosing(WindowEvent e)
        {
            this.dispose();
            if (e.getSource()==iptables_dia)
                iptables_dia=null;
            else
                userspace_dia=null;
        }
        public void windowClosed(WindowEvent e)
        {
        }
        public void windowIconified(WindowEvent e)
        {
        }
        public void windowDeiconified(WindowEvent e)
        {
        }
        public void windowActivated(WindowEvent e)
        {
        }
        public void windowDeactivated(WindowEvent e)
        {
        }
    }

    // a custom button class, which implements an Action Listener. All buttons of this client 
    // are handled in this class. It accesses the fireflier variables
    class myButton extends Button implements ActionListener
    {
        String ident;

        // activate the constructor on creation of a new mybutton
        myButton(String caption, String ident)
        {
            super(caption);
            this.ident=ident;
            this.addActionListener(this);
        }

        // handler for clicked button
        public void actionPerformed(ActionEvent e)
        {
            byte[] msg;
            String id=((myButton)(e.getSource())).ident;
            if (id.equals("packet_allow")) // main frame: accept button
            {
                setLabels("", "", "", "", "", "", "", "", "", "", "", "", "", "");
                sendmsg(3);
                reset_checkboxes();
                curMsglen=-1;
                System.out.println("accept packet");
            } else if (id.equals("packet_deny")) // main frame: deny button
            {
                setLabels("", "", "", "", "", "", "", "", "", "", "", "", "", "");
                sendmsg(4);
                reset_checkboxes();
                curMsglen=-1;
            } else if (id.equals("delete_rule")) // iptables-rules dialog: delete
            {
                int chain=1;
                int rulenum=0;
                int selected;

                selected=iptables_dialogList.getSelectedIndex();
                System.out.println(""+inputStart+" "+forwardStart+" "+outputStart);
                System.out.println("Selected: "+selected);
                if ((inputStart<selected) && (selected<forwardStart)) // which chain was this rule in
                {
                    chain=1;
                    rulenum=selected-inputStart-1;
                } else if ((forwardStart<selected) && (selected<outputStart))
                {
                    chain=2;
                    rulenum=selected-forwardStart-1;
                } else
                {
                    chain=3;
                    rulenum=selected-outputStart-1;
                }
                if ((rulenum>0) && (selected!=forwardStart-1) && (selected!=outputStart-1))
                {
                    sendmsg(5, chain, rulenum);
                    System.out.println("Deleting rule "+rulenum+" of chain "+chain);
                }
            } else if (id.equals("delete_userspace_rule")) { // userspace-rules frame: delete
                int selected=userspace_dialogList.getSelectedIndex();
                System.out.println("selected"+selected);
                sendmsg(7, 0, selected); // 0 ... not important in this context
            }
            else if (id.equals("login_send")) // login dialog: send
            {
                ((myButton)e.getSource()).getParent().setVisible(false);
            }
            else if (id.equals("close_about")) // about dialog: close
            {
                ((myButton)e.getSource()).getParent().setVisible(false); 
            }
            else if (id.equals("close_iptables")) // iptables-dialog: close
            {
		((myDialog)(((myButton)e.getSource()).getParent().getParent())).dispose();
                iptables_dia=null;
            }
            else if (id.equals("close_userspace")) // userspace-dialog: close
            {
                ((myDialog)(((myButton)e.getSource()).getParent().getParent())).dispose();
                userspace_dia=null;
            }
        }
    }

    // a custom checkbox which has a handler for clicked checkbox
    // when a checkbox is clicked, I maybe have to disable others
    class myCheckbox extends Checkbox implements ItemListener {
        // add handler on creation of new mycheckbox
        myCheckbox(String label)
        {
            super(label);
            this.addItemListener(this);
        }
        myCheckbox(String label, CheckboxGroup group, boolean state)
        {
            super(label, group, state);
            this.addItemListener(this);
        }

        // handler for clicked checkbox
        public void itemStateChanged(ItemEvent e)
        {
            if (e.getStateChange()==ItemEvent.SELECTED) // only selecting items is important
            {
                if ((e.getSource()==cb_ip_src) || // any checkbox for specifying rule?
                    (e.getSource()==cb_ip_dst) || 
                    (e.getSource()==cb_port_src) || 
                    (e.getSource()==cb_port_dst) || 
                    (e.getSource()==cb_interface_in) || 
                    (e.getSource()==cb_interface_out) || 
                    (e.getSource()==cb_protocol) || 
                    (e.getSource()==cb_programname) || 
                    (e.getSource()==cb_conntrack))
                {
                    // set create rule checkbox to true (and automatically unset the other two)
                    cb_create_rule.setState(true); 
                }
                if ((e.getSource()==cb_this_packet) || // any non-create rule checkbox clicked?
                    (e.getSource()==cb_queued_packets))
                {
                    cb_ip_src.setState(false); // clear all checkboxes for specifying rules
                    cb_ip_dst.setState(false);
                    cb_port_src.setState(false);
                    cb_port_dst.setState(false);
                    cb_interface_in.setState(false);
                    cb_interface_out.setState(false);
                    cb_protocol.setState(false);
                    cb_programname.setState(false);
                    cb_conntrack.setState(false);
                }
            }
        }
    }

    // a custom Menuitem with a handler for clicking (=selecting this menuitem)
    class myMenuItem extends MenuItem implements ActionListener {
        String ident;    
        // add handler on every new mymenuitem
        public myMenuItem(String caption, String ident)
        {
            super(caption);
            this.addActionListener(this);
            this.ident=ident;
        }

        // handler for clicking
        public void actionPerformed(ActionEvent e)
        {
            byte[] msg;
            String id=((myMenuItem)(e.getSource())).ident;
            if (id.equals("view_source")) // want show packet source?
                sendcmd(1); // request source. (Displaying is done automatically when receiving corresponding packet.)
            else if (id.equals("view_iptables")) // want show iptables rules?
                sendcmd(2); // request iptables rules
            else if (id.equals("view_userspace")) // want to show userspace rules ?
                sendcmd(6); // request userspace rules
            else if (id.equals("about")) // show about box
            {
                Dialog aboutdia=new myDialog(fireflier.this, "about - fireflier", true);
                aboutdia.setLayout(new GridLayout(6, 1));
                aboutdia.add(new Label("Author: Martin Maurer"));
                aboutdia.add(new Label("Nickname: lonestar"));
                aboutdia.add(new Label("E-Mail: fireflier@gibraltar.at"));
                aboutdia.add(new Label("ICQ: 20359568"));
                aboutdia.add(new Label("Copyright: GPL"));
                aboutdia.add(new myButton("Close", "close_about"));
                aboutdia.pack();
                aboutdia.show(); // modal dialog
            }
        }
    }

    // set checkboxes to "unchecked" values.
    void reset_checkboxes()
    {
        cb_ip_src.setState(false);
        cb_ip_dst.setState(false);
        cb_port_src.setState(false);
        cb_port_dst.setState(false);
        cb_interface_in.setState(false);
        cb_interface_out.setState(false);
        cb_protocol.setState(false);
        cb_conntrack.setState(false);
        cb_this_packet.setState(true);
        cb_programname.setState(false);
        ch_timeout.select(0);
    }

    // send a request to the server (mostly this one is used)
    void sendmsg(int id)
    {
        byte[] msg=new byte[17];

        System.out.println("Sending command "+id);

        // states of checkboxes are sent too.
        msg[0]=(byte)id;
        msg[1]=0;
        if (cb_this_packet.getState())
            msg[2]=1;
        else if (cb_queued_packets.getState())
            msg[2]=2;
        else
            msg[2]=3;

        msg[3]=(cb_ip_src.getState())?(byte)1:(byte)0;
        msg[4]=(cb_ip_dst.getState())?(byte)1:(byte)0;
        msg[5]=(cb_port_src.getState())?(byte)1:(byte)0;
        msg[6]=(cb_port_dst.getState())?(byte)1:(byte)0;
        msg[7]=(cb_interface_in.getState())?(byte)1:(byte)0;
        msg[8]=(cb_interface_out.getState())?(byte)1:(byte)0;
        msg[9]=0; //(cb_mac_addr.getState())?(byte)1:(byte)0;
        msg[10]=(cb_protocol.getState())?(byte)1:(byte)0;
        msg[11]=(cb_conntrack.getState())?(byte)1:(byte)0;
        msg[12]=(cb_programname.getState())?(byte)1:(byte)0;

        // the timeout values of the interface are translated to seconds
        if (ch_timeout.getSelectedItem().equals("forever"))
        {
            msg[13]=0; // reserved for timeout
            msg[14]=0;
            msg[15]=0;
            msg[16]=0;
        }
        else if (ch_timeout.getSelectedItem().equals("5 minutes"))
        {
            msg[13]=0; // reserved for timeout
            msg[14]=0;
            msg[15]=1;
            msg[16]=(byte)224;
        }
        else if (ch_timeout.getSelectedItem().equals("1 hour"))
        {
            msg[13]=0; // reserved for timeout
            msg[14]=0;
            msg[15]=14;
            msg[16]=16;
        }
        else if (ch_timeout.getSelectedItem().equals("1 day"))
        {
            msg[13]=0; // reserved for timeout
            msg[14]=1;
            msg[15]=81;
            msg[16]=(byte)128;
        }

        try
        {
            if (socket!=null)
                socket.getOutputStream().write(msg);
        } catch (IOException io)
        {
            System.out.println("Could not send message");
        }
        // if a rule is inserted by the client and the iptables dialog is opened, 
        // request the new iptables rules
        if ((iptables_dia!=null) && (id!=2) && (id!=6))
        {
            sendcmd(2);
        }
        // if a rule is inserted by the client and the userspace dialog is opened, 
        // request the new userspace rules
        if ((userspace_dia!=null) && (id!=6) && (id!=2))
        {
            sendcmd(6);
        }
    }
    // only send a short command. (for requesting rules and source)
    void sendcmd(int id)
    {
        byte[] msg=new byte[2];

        msg[0]=(byte)id;
        msg[1]=0;
        try
        {
            if (socket!=null)
                socket.getOutputStream().write(msg);
        } catch (IOException io)
        {
            System.out.println("Could not send message");
        }
    }

    // send command (deleting iptables/userspace rules)
    void sendmsg(int id, int chain, int rulenum)
    {
        byte[] msg=new byte[5];

        msg[0]=(byte)id; 
        msg[1]=0;
        msg[2]=(byte)chain;
        msg[3]=(byte)(rulenum&255);
        msg[4]=(byte)(rulenum>>8);
        try
        {
            if (socket!=null)
                socket.getOutputStream().write(msg);
        } catch (IOException io)
        {
            System.out.println("Could not send message");
        }
    }

    // set a checkbox to a value or, if value is "" set to "not available"
    void setCheckbox(Checkbox cb, String str)
    {
        if (!str.trim().equals(""))
        {
            cb.setLabel(str);
            cb.setEnabled(true);
        }
        else
        {
            cb.setLabel("not available");
            cb.setEnabled(false);
        }
    }

    // set labels to match current packet
    // uses setCheckbox
    public void setLabels(String ip_src, String ip_dst, String mac_addr, String port_src, String port_dst, String protocol, String interface_in, String interface_out, String len, String tcp_flags, String icmp_type, String arrived, String hook, String programname)
    {
        System.out.println("Setting labels: "+ip_src+" "+ip_dst+" "+port_src+" "+port_dst+" "+mac_addr+" "+protocol);
        
        setCheckbox(cb_ip_src, ip_src);
        setCheckbox(cb_ip_dst, ip_dst);

//        this.cb_mac_addr.setLabel(mac_addr);
        this.label_mac_addr.setText(mac_addr.equals("")?"not available":mac_addr);
        setCheckbox(cb_port_src, port_src);
        setCheckbox(cb_port_dst, port_dst);
        setCheckbox(cb_protocol, protocol);
        setCheckbox(cb_interface_in, interface_in);
        setCheckbox(cb_interface_out, interface_out);
        setCheckbox(cb_programname, programname);
        this.label_len.setText(len.equals("")?"not available":len);
        this.label_tcp_flags.setText(tcp_flags.equals("")?"not available":tcp_flags);
        this.label_icmp_type.setText(icmp_type.equals("")?"not available":icmp_type);
        this.label_arrived.setText(arrived.equals("")?"not available":arrived);
        this.label_hook.setText(hook.equals("")?"not available":hook);
        if (!ip_src.equals("")) { // enable all interface items and do the new lookup
            cb_conntrack.setEnabled(true);
            cb_create_rule.setEnabled(true);
            cb_queued_packets.setEnabled(true);
            cb_this_packet.setEnabled(true);
            ch_timeout.setEnabled(true);
            label_len.setEnabled(true);
            label_tcp_flags.setEnabled(true);
            label_icmp_type.setEnabled(true);
            label_arrived.setEnabled(true);
            label_hook.setEnabled(true);
            label_mac_addr.setEnabled(true);
            lookupThr.lookup(ip_src.substring(6), ip_dst.substring(6));
            label_ip_src.setEnabled(true);
            label_ip_dst.setEnabled(true);
            this.label_ip_src.setText("resolving...");
            this.label_ip_dst.setText("resolving...");
        }
        else // no current packet --> disable interface items
        {
            lookupThr.lookup("", "");
            cb_create_rule.setEnabled(false);
            cb_queued_packets.setEnabled(false);
            cb_conntrack.setEnabled(false);
            cb_this_packet.setEnabled(false);
            ch_timeout.setEnabled(false);
            label_len.setEnabled(false);
            label_tcp_flags.setEnabled(false);
            label_icmp_type.setEnabled(false);
            label_arrived.setEnabled(false);
            label_hook.setEnabled(false);
            label_mac_addr.setEnabled(false);
            label_ip_src.setEnabled(false);
            label_ip_dst.setEnabled(false);
            this.label_ip_src.setText("not available");
            this.label_ip_dst.setText("not available");
        }
    }

    public void windowOpened(WindowEvent e)
    {
    }
    public void windowClosing(WindowEvent e)
    {
        try
        {
            if (socket!=null)
                socket.close();
        } catch (IOException io)
        {
        }
        System.exit(0);
    }
    public void windowClosed(WindowEvent e)
    {
    }
    public void windowIconified(WindowEvent e)
    {
    }
    public void windowDeiconified(WindowEvent e)
    {
    }
    public void windowActivated(WindowEvent e)
    {
    }
    public void windowDeactivated(WindowEvent e)
    {
    }

    // return a byte(-128 - 127) as an integer(0-255)
    public int unsigned(byte b)
    {
        return(b+256)%256;
    }

    // organize the buffer, which is received from the server into a packet
    public void scanpacket(byte[] buffer)
    {
        String packet_id="";
        String ip_src="";
        String ip_dst="";
        String interface_in="";
        String interface_out="";
        String mac_addr="";
        String port_src="";
        String port_dst="";
        String protocol="";
        String tcp_flags="";
        String icmp_type="";
        String arrived="";
        String len="";
        String hook=""; // ==chain
        String programname;

        int temp=0;
        int pos;

        // read packet id - not used in the interface at the moment
        packet_id=""+((buffer[0])<<24+(buffer[1]<<16)+(buffer[2]<<8)+buffer[3]);
        temp=(unsigned(buffer[4])<<24)+(unsigned(buffer[5])<<16)+(unsigned(buffer[6])<<8)+(unsigned(buffer[7]));
        // date when the packet arrived at the firewall
        arrived=""+(new Date(temp)).toString();

        temp=unsigned(buffer[8])*256+unsigned(buffer[9]);
        curMsglen=temp;
        len="LEN="+temp; // length of packet
        
        // ip addresses
        ip_src="SRCIP="+unsigned(buffer[13])+"."+unsigned(buffer[12])+"."+unsigned(buffer[11])+"."+unsigned(buffer[10]);
        ip_dst="DSTIP="+unsigned(buffer[17])+"."+unsigned(buffer[16])+"."+unsigned(buffer[15])+"."+unsigned(buffer[14]);

        switch (buffer[18]) // protocol
        {
        case 1:
            protocol="ICMP";
            break;
        case 6:
            protocol="TCP";
            break;
        case 17:
            protocol="UDP";
            break;
        case 47:
            protocol="GRE";
            break;
        default:
            protocol="Unknown: "+buffer[18];
            break;
        }

        // ports
        if ((protocol.equals("TCP")) || (protocol.equals("UDP")))
        {
            port_src="SPT="+(unsigned(buffer[19])*256+unsigned(buffer[20]));
            port_dst="DPT="+(unsigned(buffer[21])*256+unsigned(buffer[22]));
        } else
        {
            port_src="no SPT";
            port_dst="no DPT";
        }

        // TCP flags
        if (protocol.equals("TCP"))
        {
            // decode flags
            temp=unsigned(buffer[23])*256+buffer[24];
            if ((temp&4)!=0) tcp_flags+="ACK ";
            if ((temp&8)!=0) tcp_flags+="RST ";
            if ((temp&2)!=0) tcp_flags+="SYN ";
            if ((temp&1)!=0) tcp_flags+="FIN ";

            tcp_flags="FLAGS="+tcp_flags;
        }
        else
            tcp_flags="not TCP";

        // ICMP Type
        if (protocol.equals("ICMP"))
        {
            //decode type
            icmp_type="TYPE="+ICMP_TYPES[buffer[25]];
        }
        else
            icmp_type="not ICMP";

        // chains
        switch (buffer[26])
        {
        case 1:
            hook="CHAIN=INPUT";
            break;
        case 2:
            hook="CHAIN=FORWARD";
            break;
        case 3:
            hook="CHAIN=OUTPUT";
            break;
        default:
            hook="UNKNOWN: "+buffer[26];
            break;
        }

        String colon="";
        temp=buffer[27];
        pos=0;
        while (pos<temp) // hardware address of network interface card
        {
            mac_addr+=colon+HEX[unsigned(buffer[28+pos])>>4]+HEX[unsigned(buffer[28+pos])&15];
            pos++;
            colon=":";
        }
        mac_addr="mac="+mac_addr;

        pos=0;
        // network interface names
        while ((pos<16))
        {
            interface_in+=(char)buffer[pos+36];
            pos++;
        }
        if (interface_in.equals(""))
            interface_in="no incoming interface";

        pos=0;
        while ((pos<16))
        {
            interface_out+=(char)buffer[pos+52];
            pos++;
        }
        if (interface_out.equals(""))
            interface_out="no outgoing interface";
        
        protocol="PROTOCOL="+protocol;

        // name of associated program (if any found)
        temp=buffer[68];
        pos=0;
        programname="";
        while ((pos<temp) && (buffer[pos+69]!=0)) {
            programname+=(char)buffer[pos+69];
            pos++;
        }
        programname="Program="+programname;

        // update labels / checkboxes
        setLabels(ip_src, ip_dst, mac_addr, port_src, port_dst, protocol, interface_in, interface_out, len, tcp_flags, icmp_type, arrived, hook, programname);

    }

    // format the message source to a hex-viewer style output
    public String getSourceFormatted(byte[] src)
    {
        String result="";
        int pos=0;

        if (src==null) return "";

        while (pos<src.length)
        {
            for (int i=0;i<16;i++)
            {
                if (i==8)
                    result+="  ";
                else if (i%4==0) 
                    result+=" ";
                if (i+pos<src.length)
                    result+=""+(char)HEX[unsigned(src[i+pos])>>4]+""+(char)HEX[unsigned(src[i+pos])&15]+" ";
                else
                    result+="   ";
            }
            result+="   ";
            for (int i=0;i<16;i++)
            {
                if (i==8)
                    result+="  ";
                else if (i%4==0) 
                    result+=" ";
                
                if ((i+pos<src.length) && (src[i+pos]>=32))
                    result+=(char)src[i+pos];
                else
                    result+=".";
            }
            pos+=16;
            result+="\n";
        }
        return result;
    }

    // this function is used to catch receives which terminate too early
    // I dont know why this happens, but at least this fixes it. 
    public int myread(InputStream in, byte[] buffer)
    {
        int count=0;
        int result=0;

        try
        {
            while (count+result<buffer.length) // receive until complete packet received
            {
                count+=result;
                result=in.read(buffer, count, buffer.length-count);
                if (result==-1)
                {
                    return(-1);
                }
            }
        } catch (IOException io)
        {
            return -1;
        }
        return count;
    }

    public void run() // Connection to server
    {
        InputStream in;
        OutputStream out;
        byte[] msg=null;
        int len;
        int msgtype;
        int temp;
        int ok=0;
        
        Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());
        SSLSocketFactory ssl_factory = (SSLSocketFactory)SSLSocketFactory.getDefault();

        try
        {
            // initialize SSL connection to server
            System.setProperty("java.protocol.handler.pkgs", "com.sun.net.ssl.internal.www.protocol");
            java.security.Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());
            X509TrustManager tm = new MyX509TrustManager();
            KeyManager []km = null;
            TrustManager []tma = {tm};
            SSLContext sslContext = SSLContext.getInstance("SSL");
            sslContext.init(km,tma,new java.security.SecureRandom());
            SSLSocketFactory sf = sslContext.getSocketFactory();
            socket=(SSLSocket)sf.createSocket(InetAddress.getByName(ServerIP), Integer.valueOf(ServerPort).intValue());
            System.out.println("Starting handshake");
            socket.startHandshake();
            System.out.println("handshake done");
            in=socket.getInputStream();
            out=socket.getOutputStream();


            do { // login to server
                TextField username=new TextField();
                TextField password=new TextField();
                
                // Password Dialog 
                password.setEchoChar('*');
                myDialog pwddia=new myDialog(this, "Login to Server", true);
                pwddia.setLayout(new GridLayout(3, 2));
                pwddia.add(new Label("Username"));
                pwddia.add(username);
                pwddia.add(new Label("Password"));
                pwddia.add(password);
                pwddia.add(new myButton("Send", "login_send"));
                pwddia.setSize(300, 120);
                pwddia.show();

                // Send header
                len=username.getText().length();
                len+=password.getText().length();
                len+=6;
                msg=new byte[len];
                msg[0]=(byte)8; // auth message type
                msg[1]=0;

                // send username
                len=username.getText().length();
                msg[2]=(byte)(len&255);
                msg[3]=(byte)(len>>8);
                byte[] tempmsg=username.getText().getBytes();
                for (int i=0;i<tempmsg.length;i++)
                    msg[i+4]=tempmsg[i];
                
                // send password
                int pos=username.getText().length()+4;
                len=password.getText().length();
                msg[pos]=(byte)(len&255);
                msg[pos+1]=(byte)(len>>8);
                tempmsg=password.getText().getBytes();
                for (int i=0;i<tempmsg.length;i++)
                    msg[pos+2+i]=tempmsg[i];

                // send message
                out.write(msg);

                // receive answer
                if ((temp=in.read())==-1) throw new IOException("Server down");
                msgtype=temp;
                if (msgtype!=8)
                {
                    System.out.println("Protocol violation. Exiting\n"+msgtype);
                    System.exit(1);
                }
                System.out.println("Done\n");
                if ((temp=in.read())==-1) throw new IOException("Server down");
                ok=temp;
            } while (ok==0);

            while (true) // receive packets until server dies
            {
                int count;
                if ((temp=in.read())==-1) throw new IOException("Server down");
                msgtype=temp;

                switch (msgtype)
                {
                case 0: // receive network packet
                    int msglen;
                    if ((temp=in.read())==-1) throw new IOException("Server down");
                    msglen=temp*256;
                    if ((temp=in.read())==-1) throw new IOException("Server down");
                    msglen+=temp;

                    System.out.println("Msglen: "+msglen);

                    msg=new byte[msglen-3];
                    if ((count=myread(in,msg))==-1) throw new IOException("Server down");
                    System.out.println("Received "+count+" bytes(2)");
                    break;
                case 1: // received packet source
                    msg=new byte[curMsglen];
                    if ((count=myread(in, msg))==-1) throw new IOException("Server down");
                    System.out.println("Received "+count+" bytes");
                    break;
                case 6: // iptables / userspace rules
                case 2:
                    int rulelen;
                    if ((temp=in.read())==-1) throw new IOException("Server down");
                    rulelen=temp*256;
                    if ((temp=in.read())==-1) throw new IOException("Server down");
                    rulelen+=temp;

                    System.out.println("RULELEN:"+rulelen);
                    msg=new byte[rulelen];
                    if ((count=myread(in, msg))==-1) throw new IOException("Server down");
                    System.out.println("Received "+count+" bytes(3)");
                    break;
                default:
                    System.out.println("UNKNOWN MESSAGE !!!");
                    break;
                }
                System.out.println("Received message - parsing");
                if (msg!=null)
                {
//                    for (int i=0;i<msg.length;i++)
//                        System.out.print((msg[i]+256)%256+" ");
//                    System.out.println();

                    if (msgtype==0) // a new firewall packet
                    {
                        System.out.println("scanning packet");
                        scanpacket(msg);
                    } else if (msgtype==1)  // source of the current packet
                    {
                        myDialog sourcedia=new myDialog(this, "Source of packet", true);
                        sourcedia.setSize(400, 300);
                        TextArea t=new TextArea(getSourceFormatted(msg));
                        t.setEditable(false);
                        sourcedia.add(t);
                        sourcedia.show();
                    } else if (msgtype==2) // iptables rules
                    {
                        inputStart=-1; // for searching the chain boundaries
                        outputStart=-1;
                        forwardStart=-1;
                        int pos=0;
                        String rules="";
                        for (int i=0;i<msg.length;i++)
                            rules+=(char)msg[i];

                        if (iptables_dia==null) // if iptables window is not opened, create it
                        {
                            iptables_dia=new myDialog(this, "Firewall rules", false);
                            iptables_dia.setSize(800, 300);
                            iptables_dialogList=new List();
                            iptables_dia.setLayout(new BorderLayout());
                            iptables_dia.add(iptables_dialogList);
                            Panel buttons=new Panel();
                            buttons.setLayout(new GridLayout(1,2));
                            buttons.add(new myButton("delete this rule", "delete_rule"));
                            buttons.add(new myButton("close", "close_iptables"));
                            iptables_dia.add(buttons, BorderLayout.SOUTH);
                        } else // otherwise only empty it
                        {
                            int index=iptables_dialogList.getVisibleIndex();
                            iptables_dialogList.removeAll();
                            System.out.println("INDEX:"+index);
                        }
                        temp=0;
                        count=0;
                        // fill in rules data and get chain boundaries
                        while ((temp<rules.length()) && (pos!=-1)) 
                        {
                            pos=rules.indexOf("\n", temp);
                            if (pos>=temp)
                            {
                                String line=rules.substring(temp, pos);
                                if (line.startsWith("Chain INPUT"))
                                    inputStart=count;
                                if (line.startsWith("Chain OUTPUT"))
                                    outputStart=count;
                                if (line.startsWith("Chain FORWARD"))
                                    forwardStart=count;
                                iptables_dialogList.add(line);
                                temp=pos+1;
                                count++;
                            }
                        }
                        // may be called even if visible
                        iptables_dia.show();
                    } else if (msgtype==6) // get userspace rules
                    {
                        int pos=0;
                        String rules="";
                        for (int i=0;i<msg.length;i++)
                            rules+=(char)msg[i];
    
                        if (userspace_dia==null) // if userspace dialog is not opened, create it
                        {
                            userspace_dia=new myDialog(this, "Firewall userspace rules", false);
                            userspace_dia.setSize(800, 300);
                            userspace_dialogList=new List();
                            userspace_dia.setLayout(new BorderLayout());
                            userspace_dia.add(userspace_dialogList);
                            Panel buttons=new Panel();
                            buttons.setLayout(new GridLayout(1,2));
                            buttons.add(new myButton("delete this rule", "delete_userspace_rule"));
                            buttons.add(new myButton("close", "close_userspace"));
                            userspace_dia.add(buttons, BorderLayout.SOUTH);
                        } else // otherwise empty it
                        {
                            int index=userspace_dialogList.getVisibleIndex();
                            userspace_dialogList.removeAll();
                            System.out.println("INDEX:"+index);
                        }
                        temp=0;
                        count=0;
                        while ((temp<rules.length()) && (pos!=-1)) // fill in rules
                        {
                            pos=rules.indexOf("\n", temp);
                            if (pos>=temp)
                            {
                                String line=rules.substring(temp, pos);
                                userspace_dialogList.add(line);
                                temp=pos+1;
                                count++;
                            }
                        }
                        // may be called even if visible
                        userspace_dia.show();
                    }
                    msg=null;
                }
            }

        } catch (IOException io)
        {
            System.out.println("Error while communicating");
            io.printStackTrace();
            try
            {
                if (socket!=null)
                    socket.close();
            } catch (IOException io2)
            {
            }
            System.exit(1);
        }
        catch (java.security.NoSuchAlgorithmException nsa)
        {
            System.out.println("No such algorithm exception");
            nsa.printStackTrace();
        }
        catch (java.security.KeyManagementException kme)
        {
            System.out.println("Key Management exception");
            kme.printStackTrace();

        }


    }

    // organize components in the GridbagLayout class
    public void constrain(Container cont, Component comp,
                          int grid_x, int grid_y, int grid_width, int grid_height,
                          int fill, int anchor, double weight_x, double weight_y,
                          int top, int left, int bottom, int right)
    {
        GridBagConstraints c = new GridBagConstraints();
        c.gridx=grid_x;
        c.gridy=grid_y;
        c.gridwidth=grid_width;
        c.gridheight=grid_height;
        c.fill=fill;
        c.anchor=anchor;
        c.weightx=weight_x;
        c.weighty=weight_y;
        if (top+bottom+left+right>0)
            c.insets=new Insets(top, left, bottom, right);
        ((GridBagLayout)cont.getLayout()).setConstraints(comp, c);
        cont.add(comp);
    }

    // constructor
    public fireflier()
    {
        super("FireFlier Client"); // window title
        lookupThr=new lookupThread(); // start thread forresolving ips to hostnames 
        Label label_empty;
        GridBagLayout gridbag=new GridBagLayout();
        MenuBar menubar=new MenuBar();
        Menu menu=new Menu("Edit");
        
        // create Menu
        menu.add(new myMenuItem("view source", "view_source"));
        menu.add(new myMenuItem("view iptables rules", "view_iptables"));
        menu.add(new myMenuItem("view userspace rules", "view_userspace"));
        menubar.add(menu);

        menu=new Menu("Help");
        menu.add(new myMenuItem("About", "about"));
        menubar.setHelpMenu(menu);

        this.setMenuBar(menubar);        


        Panel upper, lower;

        upper=new Panel();
        lower=new Panel();
        Panel empty=new Panel();

        this.setLayout(gridbag);

        // two frames one for the buttons, one for the rest
        constrain(this, upper, 0, 0, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,1.0,0.99,0,0,0,0);
        constrain(this, lower, 0, 1, 1, 1,GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST,1.0,0.01,0,0,0,0);
        upper.setLayout(new GridLayout(11, 2));
        lower.setLayout(gridbag);

        // initialize labels and checkboxes
        label_len=new Label("Message Length");
        label_tcp_flags=new Label("TCP Flags");
        label_icmp_type=new Label("ICMP_Type");
        label_arrived=new Label("arrived");
        label_hook=new Label("chain");
        label_empty=new Label("");
        label_ip_src=new Label("Source IP-Name");
        label_ip_dst=new Label("Destination IP-Name");

        cb_ip_src=new myCheckbox("Source IP");
        cb_ip_dst=new myCheckbox("Destination IP");
        cb_port_src=new myCheckbox("Source Port");
        cb_port_dst=new myCheckbox("Destination Port");
        cb_interface_in=new myCheckbox("incoming interface");
        cb_interface_out=new myCheckbox("outgoing interface");
//        cb_mac_addr=new myCheckbox("MAC address");
        label_mac_addr=new Label("MAC address");
        cb_protocol=new myCheckbox("Protocol");
        cb_conntrack=new myCheckbox("Connection tracking");
        cb_programname=new myCheckbox("Programname");
           

        CheckboxGroup cbg=new CheckboxGroup();
        cb_this_packet=new myCheckbox("this packet", cbg, true);
        cb_queued_packets=new myCheckbox("queued packets", cbg, false);
        cb_create_rule=new myCheckbox("create rule from this packet", cbg, false);

        ch_timeout=new Choice();
        ch_timeout.add("forever");
        ch_timeout.add("5 minutes");
        ch_timeout.add("1 hour");
        ch_timeout.add("1 day");

        // organize label and checkboxes into upper frame
        upper.setLayout(gridbag);
        constrain(upper, cb_this_packet,    0,  0, 3, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.1,0.0,0,0,0,0);
        constrain(upper, cb_queued_packets, 0,  1, 3, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.1,0.0,0,0,0,0);
        constrain(upper, cb_create_rule,    0,  2, 3, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.1,0.0,0,0,0,0);

        constrain(upper, (new Panel()).add(new Label("  ")), 0,  3, 1, 9,GridBagConstraints.NONE, GridBagConstraints.NORTHWEST,0.0,0.0,0,0,0,0);
        constrain(upper, label_hook,                         1,  3, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, new Label("Source of packet"),      1,  4, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, new Label("Destination of packet"), 2,  4, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        
        constrain(upper, cb_ip_src,         1,  5, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, cb_ip_dst,         2,  5, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, label_ip_src,      1,  6, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, label_ip_dst,      2,  6, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, cb_port_src,       1,  7, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, cb_port_dst,       2,  7, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, cb_interface_in,   1,  8, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, cb_interface_out,  2,  8, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, label_mac_addr,    1,  9, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, cb_protocol,       2,  9, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, label_len,         1, 10, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, label_tcp_flags,   2, 10, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, label_icmp_type,   1, 11, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, label_arrived,     1, 12, 2, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, cb_conntrack,      1, 14, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, cb_programname,    1, 13, 2, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);
        constrain(upper, ch_timeout,        2,  3, 1, 1,GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST,0.7,0.0,0,0,0,0);

        upper.setFont(new Font("Courier", Font.BOLD, 12));
        lower.setFont(new Font("Courier", Font.BOLD, 12));

        // organize the two buttons into lower frame
        constrain(lower, new myButton("accept", "packet_allow"), 0, 0, 1, 1,GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST,1.0,1.0,0,0,0,0);
        constrain(lower, new myButton("deny", "packet_deny"), 1, 0, 1, 1,GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST,1.0,1.0,0,0,0,0);

        this.addWindowListener(this);
    }

    public static void main(String[] args)
    {
        fireflier cl=new fireflier();

        ServerIP="127.0.0.1"; // default IP is our own host
        ServerPort="1133"; // just some port I liked :)
        if (args.length>=1)
            ServerIP=args[0];
        if (args.length>=2)
            ServerPort=args[1];

        Thread conn=new Thread(cl); // thread for receiving packets from server
        conn.start();
        
        new Thread(cl.lookupThr).start(); // start lookup thread


        cl.pack();
        cl.show(); // show the interface. never returns
    }
}

